#Who's On 2.0
#By Computrius

USES USER
USES CFG

GetCFG
GetThisUser

#***ChatX.dat info**********
var 
   Active Boolean,
   Name String, #[30]    
   Action String, #[40]  
   Location String, #[30]
   Gender Char,          
   Age Byte,             
   Baud String, #[6]     
   Invisible Boolean,    
   Available Boolean,    
   InChat Boolean,       
   Room Byte         
#***************************

#var  DataFile String Array(1..25)
var  ConfigFile String Array(1..175) #175
var  NumberOfNodes Integer
var  CurrentNode Integer
var  Dummy String
var  MiscLoop Integer
var  DispVal Integer

Procedure LoadDummys(NumDum Integer)
Begin
  For MiscLoop := 1 to NumDum
    FReadLN(1, Dummy)
  FEnd
PEnd

Procedure LoadConfig
Begin
  fopen (1, text, reset, CFGDataPath + 'whoon.cfg')
  LoadDummys(34)
  FReadLN(1, Dummy)
  NumberOfNodes := str2int(Dummy)
  NumberOfNodes := NumberOfNodes * 5
  For CurrentNode := 1 to NumberOfNodes
    FReadLN(1, ConfigFile(CurrentNode))
  FEnd
  FClose(1)
  NumberOfNodes := NumberOfNodes / 5
PEnd

Procedure DispString (DispThiss String)
Begin
  DispVal := CurrentNode - 1
  DispVal := DispVal * 5
  DispVal := DispVal + 1  
  If DispThiss = '1101OffString1101' Then
    Write ('|' + ConfigFile(DispVal + 3) + '|' + ConfigFile(DispVal + 4) + '|[X' + ConfigFile(DispVal + 1) + '|[Y' + ConfigFile(DispVal + 2) + ' ' + ConfigFile(DispVal))
  Else      
    Write ('|' + ConfigFile(DispVal + 3) + '|' + ConfigFile(DispVal + 4) + '|[X' + ConfigFile(DispVal + 1) + ' |[Y' + ConfigFile(DispVal + 2) +  DispThiss)
  EndIf
PEnd

Function UsrOn (NodeNumber Integer) : Boolean
Begin
  IF fexist(CFGDataPath + 'Chat' + int2str(NodeNumber) + '.dat') = true then
    FOpen (2, bin, reset, CFGDataPath + 'Chat' + int2str(NodeNumber) + '.dat')
    FReadRec (2, Active)    
    UsrOn := Active
    FClose(2)  
  else
    UsrOn := False
  EndIf 
PEnd

Function UsrNme (NodeNumber Integer) : String
Begin
  IF fexist(CFGDataPath + 'Chat' + int2str(NodeNumber) + '.dat') = true then
    FOpen(2, bin, reset, CFGDataPath + 'Chat' + int2str(NodeNumber) + '.dat')
    FReadRec (2, Active)    
    FReadRec(2, Name, 30)
    UsrNme := Name
    FClose(2)
  else  
    UsrNme := 'NoBody!!'
  EndIf 
PEnd

Begin
  var myname string
  LoadConfig
  FOpen (1, text, rewrite, CFGDataPath + 'whoon.dat')
  For CurrentNode := 1 to NumberOfNodes
    If UsrOn(CurrentNode) = True then
      myname := UsrNme(CurrentNode)
      DispString (myname)
    Else
      DispString ('1101OffString1101')      
    EndIf
  FEnd
  Fclose(1)
End

